﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Runtime.InteropServices

Public Class LaSDK_Class
    <StructLayoutAttribute(LayoutKind.Sequential)> _
    Public Structure TRIG
        Public iFlag As Integer
        Public iDelay As Integer
        Public iWidth As Integer
        Public iPassCount As Integer
        Public iFreq As Integer
        Public iFreqHi As Integer
        Public iExtClk As Integer
        Public iTrPos As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public lpiCont As Integer()
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=1024)> Public lpbTrigData As Byte()

        Public Sub Initialize() 'Must Call this function before use
            ReDim lpiCont(16 - 1)
            ReDim lpbTrigData(1024 - 1)
        End Sub
    End Structure


    'Import the LASDK .DLL
    <DllImport("LASDK.dll", EntryPoint:="ulaSDKInit")> _
    Public Shared Function ulaSDKInit() As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKClose")> _
    Public Shared Function ulaSDKClose() As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKThreshold")> _
    Public Shared Function ulaSDKThreshold(ByVal iPod As Integer, ByVal iThres_mV As Integer) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKGetLaID")> _
    Public Shared Function ulaSDKGetLaID() As Integer
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKIsCaptureReady")> _
    Public Shared Function ulaSDKIsCaptureReady() As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKClearTrigger")> _
    Public Shared Function ulaSDKClearTrigger(ByRef lptr As TRIG) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKSetChTrigger")> _
    Public Shared Function ulaSDKSetChTrigger(ByRef lptr As TRIG, ByVal iLevel As Integer, ByVal iCh As Integer, ByVal iTrig As Integer, ByVal iCondLogic As Integer) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKCapture")> _
    Public Shared Function ulaSDKCapture(ByRef lptr As TRIG) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKStopCapture")> _
    Public Shared Function ulaSDKStopCapture() As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKGetBusData")> _
    Public Shared Function ulaSDKGetBusData(ByVal iMSB As Integer, ByVal iLSB As Integer, ByVal pUserData As UInt32(), ByRef lpiSize As Integer, ByVal iStartSamplePos As Integer) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKGetChData")> _
    Public Shared Function ulaSDKGetChData(ByVal iCh As Integer, ByVal pUserData As UInt32(), ByRef lpiSize As Integer, ByVal iStartSamplePos As Integer) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKSetHwInfo")> _
    Public Shared Function ulaSDKSetHwInfo(ByVal iIndex As Integer, ByRef iValue As Integer) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKGetMaxSamplesNum")> _
    Public Shared Function ulaSDKGetMaxSamplesNum() As Integer
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKGetSamplesNum")> _
    Public Shared Function ulaSDKGetSamplesNum() As Integer
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKSetSamplesNum")> _
    Public Shared Function ulaSDKSetSamplesNum(ByVal iSize As Integer) As Boolean
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKGetBufferSizeInBytes")> _
    Public Shared Function ulaSDKGetBufferSizeInBytes() As Integer
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKGetLastError")> _
    Public Shared Function ulaSDKGetLastError() As Integer
    End Function

    <DllImport("LASDK.dll", EntryPoint:="ulaSDKSaveAsLawFile")> _
    Public Shared Function ulaSDKSaveAsLawFile(ByVal szFilePathName As String) As Boolean
    End Function


    Public Shared ReadOnly TL_MAX_CH_SIZE As Integer = 36

    'Trigger Level Condition
    Public Shared ReadOnly TR_CONTINUE As Integer = 0
    Public Shared ReadOnly TR_DISCONTINUE As Integer = 1
    Public Shared ReadOnly TR_END As Integer = 2

    'Trigger Edge Type
    Public Shared ReadOnly LA_TRIG_LOW As Integer = 0
    Public Shared ReadOnly LA_TRIG_FALLING As Integer = 2
    Public Shared ReadOnly LA_TRIG_RISING As Integer = 4
    Public Shared ReadOnly LA_TRIG_HIGH As Integer = 6
    Public Shared ReadOnly LA_TRIG_DONT_CARE As Integer = 8
    Public Shared ReadOnly LA_TRIG_CHANGE As Integer = 10

    Public Shared ReadOnly TR_ONELEVEL As Integer = 0
    Public Shared ReadOnly TR_MULTILEVEL As Integer = 1
    Public Shared ReadOnly TR_DUALCOND As Integer = 2

    'LA Hardware mode setting
    Public Shared ReadOnly SET_TL_MODE As Integer = 5

    ' _TRIG:iFlag
    Public Shared ReadOnly TR_DBLMODE As Integer = &H1
    Public Shared ReadOnly TR_PRETRIG As Integer = &H2

    'LA Hardware mode
    Public Enum LA_HW_MODE As Integer
        HW_4G_36CH = 0
        HW_4G_18CH = 1
        HW_4G_9CH = 2
        HW_4G_4CH = 3
        HW_2G_36CH = 100
        HW_1600M_4CH = 200
        HW_800M_9CH = 300
        HW_400M_18CH = 400
        HW_200M_36CH = 500
        HW_200M_18CH = 501
        HW_200M_12CH = 502
        HW_200M_9CH = 503
        HW_200M_6CH = 504
        HW_200M_4CH = 505
        HW_200M_2CH = 506
        HW_200M_1CH = 507
        HW_EXT_35CH = 600
        HW_EXT_18CH = 601
        HW_EXT_12CH = 602
        HW_EXT_9CH = 603
        HW_EXT_6CH = 604
        HW_EXT_4CH = 605
        HW_EXT_2CH = 606
        HW_EXT_1CH = 607
    End Enum





    'Hardware Model Table
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure HW_INFO
        Public wID As Int16
        Public pName As String
        Public Sub New(ByVal first As Int16, ByVal second As String)
            wID = first
            pName = second
        End Sub
    End Structure



    Public Shared ReadOnly m_InfoLst As HW_INFO() = { _
        New HW_INFO(&H2036, "TL2036"), _
        New HW_INFO(&H2136, "TL2136"), _
        New HW_INFO(&H2236, "TL2236"), _
        New HW_INFO(&H2836, "TL2036E"), _
        New HW_INFO(&H2C36, "TL2136B"), _
        New HW_INFO(&H2D36, "TL2236B"), _
        New HW_INFO(&H2E36, "TL2236B+"), _
        New HW_INFO(&H2018, "TL2018E"), _
        New HW_INFO(&H2118, "TL2118E"), _
        New HW_INFO(&H1032, "LA1032"), _
        New HW_INFO(&H2032, "LA2032"), _
        New HW_INFO(&H2132, "LA2132"), _
        New HW_INFO(&H2164, "LA2164"), _
        New HW_INFO(&H1116, "PKLA1116"), _
        New HW_INFO(&H1216, "PKLA1216"), _
        New HW_INFO(&H1616, "PKLA1616"), _
        New HW_INFO(0, "")}
End Class
